

#include "tap.h"
#include "tools.h"

#define ID_START_CHANNEL		ID_BASE  +	0x0a

#define PROGRAMM_NAME			"Start Channel LCN"

TAP_ID( ID_START_CHANNEL );
TAP_PROGRAM_NAME("Start Channel LCN");
// Modified slightly by R2-D2 to use LCNs
TAP_AUTHOR_NAME("Bjrn Bckle");
TAP_DESCRIPTION("Change to a specified channel (by LCN).");
TAP_ETCINFO(__DATE__);




dword DispatchKey( dword dwKey );
dword IdleEventHandler( dword dwParam1 );
dword InitTap(dword dwParam1);
void  ExitTap();
bool g_bInit = TRUE;


word g_rgn = 0;

//-------------------------------- TAP_EventHandler ---------------------------
//
dword TAP_EventHandler( word event, dword dwParam1, dword dwParam2 )
{
	if ( event == EVT_IDLE )
		return IdleEventHandler( dwParam1 );

	if ( event == EVT_KEY )
		return DispatchKey( dwParam1 );

	return dwParam1;
}


//-------------------------------- IdleEventHandler ---------------------------
//
dword IdleEventHandler( dword dwParam1 )
{
	int svcType, svcNum;
	dword dwState, dwSubState;
	TAP_GetState (&dwState, &dwSubState);

	// if init
	if (g_bInit)
		return InitTap(dwParam1);

	// if in any menu
	if (dwState != STATE_Normal || dwSubState != SUBSTATE_Normal)
		return dwParam1;





	return dwParam1;
}


//-------------------------------- DispatchKey ---------------------------
//
dword DispatchKey( dword dwKey )
{
	return 0;
}




//-------------------------------- InitTap ---------------------------
//
dword InitTap(dword dwParam1)
{
	TYPE_File *file;
	char buffer[4];
	int channel;
	int svctype;

	g_bInit = FALSE;		// clear init flag
	memset( buffer, 0, sizeof(buffer) );

	channel = 1;						// default channel 1

	if ( file = TAP_Hdd_Fopen("StartChannelLCN.txt" ) )
	{
		TAP_Hdd_Fread( buffer, 1, 3, file );
		TAP_Hdd_Fclose (file);

		// get procent value out of text file
		if ( buffer[0] >= 0x30 && buffer[0] <=0x39 )
		{
			channel = buffer[0] - 0x30;
			if ( buffer[1] >= 0x30 && buffer[1] <=0x39 )
			{
				channel = 10*channel + buffer[1] - 0x30;
				if ( buffer[2] >= 0x30 && buffer[2] <=0x39 )
					channel = 10*channel + buffer[2] - 0x30;
			}
		}
	}
#if 0
	// now change to the desired channel
	channel--;
#else
	{
		TYPE_TapChInfo chInfo;
		int i;
		int found=FALSE;
		int numR=0, numTV=0;
		int lcn = channel;
		TAP_Channel_GetTotalNum(&numTV,&numR);
		for(i=0; !found && i<numTV; i++)
		{
			if(TAP_Channel_GetInfo(SVC_TYPE_Tv,i,&chInfo))
			{
				if(lcn == chInfo.logicalChNum)
				{
					found = TRUE;
					svctype = SVC_TYPE_Tv;
					channel = i;
				}
			}
		}
		for(i=0; !found && i<numR; i++)
		{
			if(TAP_Channel_GetInfo(SVC_TYPE_Radio,i,&chInfo))
			{
				if(lcn == chInfo.logicalChNum)
				{
					found = TRUE;
					svctype = SVC_TYPE_Radio;
					channel = i;
				}
			}
		}
	}
#endif
	if ( channel >= 0 )
//		TAP_Channel_Start( CHANNEL_Main, SVC_TYPE_Tv, channel );		// get current channel
		TAP_Channel_Start( CHANNEL_Main, svctype, channel );		// get current channel
	else
		ShowMessageWin("Error", "Invalid channel !!!", 100 );

	TAP_Exit();


	return dwParam1;
}




//-------------------------------- ExitTap ---------------------------
//
void  ExitTap()
{
	// free resources
	TAP_Exit();
}



//-------------------------------- TAP_Main ---------------------------
//
int TAP_Main(void)
{
	g_rgn = 0;
	g_bInit = TRUE;	// set init flag
	return 1;
}

